/*----------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:        
 known Problems: none
 Version:        24.10.2007
 Description:    Timer Routinen
----------------------------------------------------------------------------*/

#include "timer.h"

//----------------------------------------------------------------------------
//Diese Routine startet und inizialisiert den Timer
void timer_init (void)
{	
	//Interrupt Overfolw enable
	TIMSK |= (1 << TOIE1);
	//Setzen des Prescaler auf 1024 
	TCCR1B |= (1<<CS10 | 0<<CS11 | 1<<CS12); 
	TCNT1 = 65535 - (SYSCLK / 1024);
	return;
};

//----------------------------------------------------------------------------
//Timer1 Interrupt
ISR (TIMER1_OVF_vect)
{
	for (unsigned char a = 0;a<MAX_ARP_ENTRY;a++)
	{
		if (arp_entry[a].arp_t_time == 0)
		{
			for (unsigned char b = 0;b<6;b++)
			{
				arp_entry[a].arp_t_mac[b]= 0;
			}
			arp_entry[a].arp_t_ip = 0;
		}
		else
		{
			arp_entry[a].arp_t_time--;
		}
	}
	
	for (unsigned char index = 0;index<MAX_TCP_ENTRY;index++)
	{
		if (tcp_entry[index].time == 0)
		{
			if (tcp_entry[index].ip != 0)
			{
				tcp_entry[index].time = TCP_MAX_ENTRY_TIME;
				if ((tcp_entry[index].error_count++) > MAX_TCP_ERRORCOUNT)
				{
					DEBUG("Eintrag wird gelscht MAX_ERROR STACK:%i\r\n",index);
					tcp_index_del(index);
				}
				else
				{
					DEBUG("Packet wird erneut gesendet STACK:%i\r\n",index);
					find_and_start (index);
				}
			}
		}
		else
		{
			if (tcp_entry[index].time != TCP_TIME_OFF) 
			{
				tcp_entry[index].time--;
			}
		}
	}
	
	TCNT1 = 65535 - (SYSCLK / 1024);
}

